-- =====================================================================
-- SISTEMA : ATENDIMENTO A CLIENTES
-- DATA    : 12/01/2000
-- CRIACAO : LUCIANA
-- P_TIPOOPER = 1 - CANCELA VOO
-- P_TIPOOPER = 2 - CANCELA VOO COM COBRANA
-- MANUTENO : 11/07/2001 - LUCIANA CORREA - MULTI-EMPRESA
-- =====================================================================
-- @C:\WIN_PRJ\SQL\ORACLE\2721_ATESTP_CancelaVoo.sql
-- =====================================================================

CREATE OR REPLACE PROCEDURE CANCELA_PLANO_VOO(
  P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
  P_CDCIA        IN COMPANHIA.CDCIA%TYPE,
  P_NRVOO        IN VOO.NRVOO%TYPE,
  P_CDTRECHO     IN VOOTRECHO.CDTRECHO%TYPE,
  P_DTHRPLAVOOPV IN PLANOVOO.DTHRPLAVOOPV%TYPE,
  P_TIPOOPER     IN CHAR DEFAULT '1'

)AS

  V_SITUACAO            PLANOVOO.IDSITABASPV%TYPE;

BEGIN

  SELECT NVL(MAX(IDSITABASPV),0)
  INTO   V_SITUACAO
  FROM   PLANOVOO
  WHERE  CDFILIAL     = P_CDFILIAL AND
         CDCIA        = P_CDCIA    AND
         NRVOO        = P_NRVOO    AND
         CDTRECHO     = P_CDTRECHO AND
         DTHRPLAVOOPV = P_DTHRPLAVOOPV;

  IF V_SITUACAO = '3' THEN
    raise_application_error( -20502, 'Voo_Ja_Can', false);

    /*Manuteo no permitida. O vo j est cancelado.', false);*/
  END IF;

  /* CANCELAMENTO DO VOO */
  IF P_TIPOOPER = '1' THEN
  BEGIN
    UPDATE PLANOVOO
    SET    IDSITABASPV   = '3'
    WHERE  CDFILIAL      = P_CDFILIAL     AND
           CDCIA         = P_CDCIA        AND
           NRVOO         = P_NRVOO        AND
           CDTRECHO      = P_CDTRECHO     AND
           DTHRPLAVOOPV  = P_DTHRPLAVOOPV AND
           IDSITABASPV  IN ('1','4');

    UPDATE SERVPLANO
    SET    IDSITSERSP    = '3'
    WHERE  CDFILIAL      = P_CDFILIAL     AND
           CDCIA         = P_CDCIA        AND
           NRVOO         = P_NRVOO        AND
           CDTRECHO      = P_CDTRECHO     AND
           DTHRPLAVOOPV  = P_DTHRPLAVOOPV AND
           NRDELIVERY IS NULL             AND
           IDSITSERSP    = '1';
  END;
  /* CANCELAMENTO DO VOO COM COBRANCA */
  ELSIF P_TIPOOPER = '2' THEN
  BEGIN
    UPDATE PLANOVOO
    SET    IDSITABASPV   = '4'
    WHERE  CDFILIAL      = P_CDFILIAL     AND
           CDCIA         = P_CDCIA        AND
           NRVOO         = P_NRVOO        AND
           CDTRECHO      = P_CDTRECHO     AND
           DTHRPLAVOOPV  = P_DTHRPLAVOOPV AND
           IDSITABASPV  <> '4';
  END;
  END IF;

END;
/


-- VERSAO --
BEGIN ATUVEROBJ('CANCELA_PLANO_VOO','4.11.022'); END;
/

