/* Sistemas Integrados TECNISA
   Compras e Suprimentos

Nome: 8980_SUPTRGO_ATUALIZAR_CUSTO_ITEMCOL

Descrio:
Trigger responsvel pela identificao dos itens de cotao que devero ter o
custo de lista de preos recalculado.
O reclculo se deve ao fato destes itens de cotao terem sido alterados ou
excludos da cotao
Criao:
01/12/2006 Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE TRIGGER ATUALIZAR_CUSTO_ITEMCOL
BEFORE UPDATE OR DELETE
ON ITEMCOLE FOR EACH ROW
DECLARE
   V_CDPRODESTO PRODUTO.CDPRODUTO%TYPE;
   W_1 CHAR(1) := '1';
BEGIN
   IF UPDATING THEN
      IF NVL(:NEW.IDITECOLEALT, 'S') = NVL(:OLD.IDITECOLEALT, 'S') THEN
         :NEW.IDITECOLEALT := 'S';
      END IF;
   END IF;
   IF DELETING THEN
      IF :OLD.NRSEQPRELIST IS NOT NULL THEN
         BEGIN
            SELECT
               CDPRODESTO
            INTO
               V_CDPRODESTO
            FROM
               PRODUTO
            WHERE
               CDPRODUTO = :OLD.CDPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDPRODESTO := NULL;
         END;
         INSERT INTO ITEXCLISPREC (CDFILIAL, NRSEQPRELIST, CDREGIAO, CDPRODUTO)
         (SELECT
             :OLD.CDFILIAL,
             :OLD.NRSEQPRELIST,
             :OLD.CDREGIAO,
             V_CDPRODESTO
          FROM
             DUAL
          WHERE
             NOT EXISTS (SELECT
                            W_1
                         FROM
                            ITEXCLISPREC I
                         WHERE
                            I.CDFILIAL      = :OLD.CDFILIAL      AND
                            I.NRSEQPRELIST  = :OLD.NRSEQPRELIST  AND
                            I.CDREGIAO      = :OLD.CDREGIAO      AND
                            I.CDPRODUTO     = V_CDPRODESTO
                         )
          );
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZAR_CUSTO_ITEMCOL','4.11.110'); END;
/

